# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_identity_lib.api_client import ApiClient


class UserV3ControllerApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def patch_user_roles_on_organization(self, body, user_id, org_id, **kwargs):  # noqa: E501
        """(BETA) Update user roles in organization.  # noqa: E501

        Update service and organization roles of a user in the organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_user_roles_on_organization(body, user_id, org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrgIdRolesBody body: (required)
        :param str user_id: (required)
        :param str org_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.patch_user_roles_on_organization_with_http_info(body, user_id, org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.patch_user_roles_on_organization_with_http_info(body, user_id, org_id, **kwargs)  # noqa: E501
            return data

    def patch_user_roles_on_organization_with_http_info(self, body, user_id, org_id, **kwargs):  # noqa: E501
        """(BETA) Update user roles in organization.  # noqa: E501

        Update service and organization roles of a user in the organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_user_roles_on_organization_with_http_info(body, user_id, org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrgIdRolesBody body: (required)
        :param str user_id: (required)
        :param str org_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'user_id', 'org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_user_roles_on_organization" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_user_roles_on_organization`")  # noqa: E501
        # verify the required parameter 'user_id' is set
        if ('user_id' not in params or
                params['user_id'] is None):
            raise ValueError("Missing the required parameter `user_id` when calling `patch_user_roles_on_organization`")  # noqa: E501
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `patch_user_roles_on_organization`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user_id' in params:
            path_params['userId'] = params['user_id']  # noqa: E501
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/v3/users/{userId}/orgs/{orgId}/roles', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
